题目

给你一个字符串 s 和一个字符规律 p,请你来实现一个支持 ‘.’ 和 ‘*’ 的正则表达式匹配。

‘.’ 匹配任意单个字符
‘*’ 匹配零个或多个前面的那一个元素
所谓匹配,是要涵盖 整个 字符串 s的,而不是部分字符串。

说明:

s 可能为空,且只包含从 a-z 的小写字母。
p 可能为空,且只包含从 a-z 的小写字母,以及字符 . 和 *。
示例 1:

输入:
s = "aa"
p = "a"
输出: false
解释: "a" 无法匹配 "aa" 整个字符串。
示例 2:

输入:
s = "aa"
p = "a*"
输出: true
解释: 因为 '*' 代表可以匹配零个或多个前面的那一个元素, 在这里前面的元素就是 'a'。因此,字符串 "aa" 可被视为 'a' 重复了一次。
示例 3:

输入:
s = "ab"
p = ".*"
输出: true
解释: ".*" 表示可匹配零个或多个('*')任意字符('.')。
示例 4:

输入:
s = "aab"
p = "c*a*b"
输出: true
解释: 因为 '*' 表示零个或多个,这里 'c' 为 0 个, 'a' 被重复一次。因此可以匹配字符串 "aab"。
示例 5:

输入:
s = "mississippi"
p = "mis*is*p*."
输出: false

链接:https://leetcode-cn.com/problems/regular-expression-matching

解题记录

在这里插入图片描述

  • s,p为空 也为true dp[0][0] = true
  • 这里的状态方程需要注意的就是如果一开始就遇到*的情况并且需要跳过需要将初始dp[0][0] = true的情况向下移动
  • 正常的状态方程就是dp[i][j] = dp[i-1][j-1]
  • 将*前的字符看成一体,如果没有匹配的话,那么直接跳过dp[i][j] = dp[i][j-2]
  • 因为要传递跳过的状态因此即便能够匹配的话 pChar[j-2] == sChar[i-1],也要通过dp[i][j] = dp[i][j-2]传递true状态到跳过的那些*
/**
 * @author ffzs
 * @describe
 * @date 2020/6/20
 */
public class Solution {
    public boolean isMatch(String s, String p) {
        char[] sChar = s.toCharArray();
        char[] pChar = p.toCharArray();

        boolean[][] dp = new boolean[sChar.length+1][pChar.length+1];
        dp[0][0] = true;
        for (int i = 0; i < pChar.length; ++i) {
            if (pChar[i] == '*') dp[0][i+1] = dp[0][i-1];
        }
        for (int i = 1; i <= sChar.length; ++i) {
            for (int j = 1; j <= pChar.length; ++j) {
                if (pChar[j-1] == '*') {
                    if (pChar[j-2] == '.' || pChar[j-2] == sChar[i-1]) dp[i][j] = dp[i][j-2] || dp[i-1][j];
                    else dp[i][j] = dp[i][j-2];
                }
                else {
                    if (pChar[j-1] == '.' || pChar[j-1] == sChar[i-1]) dp[i][j] = dp[i-1][j-1];
                }
            }
        }
        return dp[sChar.length][pChar.length];
    }
}

在这里插入图片描述

Logo

北京人形旗下天工造物具身智能开源社区,聚焦具身天工与慧思开物两大平台

更多推荐